import { IInitData, OnEntryChangeCallback, OnEntryChangeCallbackUID, OnEntryChangeConfig, IStackSdk } from './utils/types.cjs';
import LivePreview from './live-preview.cjs';

interface ICSLivePreview {
    livePreview: LivePreview | null;
    userConfig: Partial<IInitData> | null;
    subscribers: {
        [uid: string]: OnEntryChangeCallback;
    };
    configs: {
        params: ConstructorParameters<typeof URLSearchParams>[0];
    };
    init: (userConfig?: Partial<IInitData>) => Promise<LivePreview> | undefined;
    hash: string;
    setConfigFromParams(params: ConstructorParameters<typeof URLSearchParams>[0]): void;
    publish(): void;
    subscribe(callback: OnEntryChangeCallback): OnEntryChangeCallbackUID;
    onEntryChange(onChangeCallback: OnEntryChangeCallback, config?: OnEntryChangeConfig): OnEntryChangeCallbackUID;
    onLiveEdit(onChangeCallback: OnEntryChangeCallback): OnEntryChangeCallbackUID;
    unsubscribeOnEntryChange(callback: string | OnEntryChangeCallback): void;
    getGatsbyDataFormat(sdkQuery: IStackSdk, prefix: string): Promise<any>;
    getSdkVersion(): string;
}
declare const ContentstackLivePreview: ICSLivePreview;

export { type ICSLivePreview, ContentstackLivePreview as default };
