"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/utils/handleUserConfig.ts
var handleUserConfig_exports = {};
__export(handleUserConfig_exports, {
  handleInitData: () => handleInitData,
  handleUserConfig: () => handleUserConfig
});
module.exports = __toCommonJS(handleUserConfig_exports);
var import__ = require("./index.cjs");
var import_public_logger = require("./public-logger.cjs");
var handleClientUrlParams = (existingConfig, userConfig) => {
  existingConfig.clientUrlParams.host = userConfig.host ?? existingConfig.clientUrlParams.host;
  existingConfig.clientUrlParams.protocol = userConfig.protocol ?? existingConfig.clientUrlParams.protocol;
  existingConfig.clientUrlParams.port = userConfig.port ?? existingConfig.clientUrlParams.port;
  if (userConfig.protocol !== void 0 && userConfig.port === void 0) {
    switch (userConfig.protocol) {
      case "http": {
        existingConfig.clientUrlParams.port = 80;
        break;
      }
      case "https": {
        existingConfig.clientUrlParams.port = 443;
        break;
      }
    }
  }
  let host = existingConfig.clientUrlParams.host;
  if (host.endsWith("/")) {
    host = host.slice(0, -1);
    existingConfig.clientUrlParams.host = host;
  }
  existingConfig.clientUrlParams.url = `${existingConfig.clientUrlParams.protocol}://${existingConfig.clientUrlParams.host}:${existingConfig.clientUrlParams.port}`;
};
function isInitDataStackSdk(initObj) {
  return Object.prototype.hasOwnProperty.call(initObj, "cachePolicy");
}
function isInitDataCommon(initObj) {
  return !isInitDataStackSdk(initObj);
}
var handleInitData = (initData, config) => {
  var _a, _b, _c, _d, _e, _f, _g, _h, _i, _j, _k, _l, _m, _n, _o, _p, _q, _r, _s, _t, _u, _v, _w, _x, _y;
  if (isInitDataStackSdk(initData)) {
    import_public_logger.PublicLogger.warn(
      "Deprecated: Do not pass the Stack object directly to the Live Preview SDK. Pass it using the config.stackSDK config object."
    );
    const livePreviewObject = (initData == null ? void 0 : initData.live_preview) || {};
    config.ssr = false;
    config.runScriptsOnUpdate = livePreviewObject.runScriptsOnUpdate ?? config.runScriptsOnUpdate;
    config.enable = livePreviewObject.enable ?? config.enable;
    config.cleanCslpOnProduction = livePreviewObject.cleanCslpOnProduction ?? config.cleanCslpOnProduction;
    config.editButton = {
      enable: (0, import__.shouldRenderEditButton)(
        livePreviewObject.editButton ?? config.editButton
      ),
      // added extra check if exclude data passed by user is array or not
      exclude: Array.isArray((_a = livePreviewObject.editButton) == null ? void 0 : _a.exclude) && ((_b = livePreviewObject.editButton) == null ? void 0 : _b.exclude) ? (_c = livePreviewObject.editButton) == null ? void 0 : _c.exclude : config.editButton.exclude ?? [],
      position: ((_d = livePreviewObject.editButton) == null ? void 0 : _d.position) ?? config.editButton.position ?? "top",
      includeByQueryParameter: ((_e = livePreviewObject.editButton) == null ? void 0 : _e.includeByQueryParameter) ?? config.editButton.includeByQueryParameter ?? true
    };
    config.stackSdk = initData;
    if (Object.prototype.hasOwnProperty.call(initData.headers, "api_key") && initData.headers.api_key)
      config.stackDetails.apiKey = initData.headers.api_key;
    if (Object.prototype.hasOwnProperty.call(initData, "environment")) {
      config.stackDetails.environment = initData.environment;
    }
    if (Object.prototype.hasOwnProperty.call(initData, "branch")) {
      config.stackDetails.branch = initData.branch;
    }
    handleClientUrlParams(
      config,
      livePreviewObject.clientUrlParams ?? config.clientUrlParams
    );
  } else if (isInitDataCommon(initData)) {
    const stackSdk = initData.stackSdk || config.stackSdk;
    config.enable = initData.enable ?? ((_f = stackSdk.live_preview) == null ? void 0 : _f.enable) ?? config.enable;
    config.ssr = initData.ssr ?? ((_g = stackSdk.live_preview) == null ? void 0 : _g.ssr) ?? (typeof initData.stackSdk === "object" ? false : true) ?? true;
    config.runScriptsOnUpdate = initData.runScriptsOnUpdate ?? ((_h = stackSdk.live_preview) == null ? void 0 : _h.runScriptsOnUpdate) ?? config.runScriptsOnUpdate;
    config.stackSdk = stackSdk;
    config.cleanCslpOnProduction = initData.cleanCslpOnProduction ?? ((_i = stackSdk.live_preview) == null ? void 0 : _i.cleanCslpOnProduction) ?? config.cleanCslpOnProduction;
    config.editButton = {
      enable: (0, import__.shouldRenderEditButton)(
        initData.editButton ?? ((_j = stackSdk.live_preview) == null ? void 0 : _j.editButton) ?? config.editButton
      ),
      // added extra check if exclude data passed by user is array or not
      exclude: Array.isArray((_k = initData.editButton) == null ? void 0 : _k.exclude) && ((_l = initData.editButton) == null ? void 0 : _l.exclude) ? (_m = initData.editButton) == null ? void 0 : _m.exclude : Array.isArray((_n = stackSdk.live_preview) == null ? void 0 : _n.exclude) && ((_o = stackSdk.live_preview) == null ? void 0 : _o.exclude) ? (_p = stackSdk.live_preview) == null ? void 0 : _p.exclude : config.editButton.exclude ?? [],
      position: ((_q = initData.editButton) == null ? void 0 : _q.position) ?? ((_r = stackSdk.live_preview) == null ? void 0 : _r.position) ?? config.editButton.position ?? "top",
      includeByQueryParameter: ((_s = initData.editButton) == null ? void 0 : _s.includeByQueryParameter) ?? ((_t = stackSdk.live_preview) == null ? void 0 : _t.includeByQueryParameter) ?? config.editButton.includeByQueryParameter ?? true
    };
    config.stackDetails.apiKey = ((_u = initData.stackDetails) == null ? void 0 : _u.apiKey) ?? ((_v = stackSdk.headers) == null ? void 0 : _v.api_key) ?? config.stackDetails.apiKey;
    config.stackDetails.environment = ((_w = initData.stackDetails) == null ? void 0 : _w.environment) ?? stackSdk.environment ?? config.stackDetails.environment;
    config.stackDetails.branch = ((_x = initData.stackDetails) == null ? void 0 : _x.branch) ?? config.stackDetails.branch ?? "main";
    handleClientUrlParams(
      config,
      initData.clientUrlParams ?? ((_y = stackSdk.live_preview) == null ? void 0 : _y.clientUrlParams) ?? config.clientUrlParams
    );
  }
};
var handleUserConfig = {
  clientUrlParams: handleClientUrlParams
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  handleInitData,
  handleUserConfig
});
//# sourceMappingURL=handleUserConfig.cjs.map